<template>
  <!-- File -->
  <v-card tile flat class="mb-3" color="transparent">
    <v-row :style="`border-left: 3px solid ${color};'`" class="pl-2 py-1 justify-space-between" no-gutters>
      <!-- Category -->
      <v-col cols="12">
        <div :style="`color: ${color};`">
          {{ fileTag.name }}
        </div>
      </v-col>

      <!-- File section -->
      <v-col cols="8" sm="8">
        <!-- Title -->
        <div>
          <a
            class="file-name studium-hyphenate"
            :href="fileDownloadUrl"
            target="blank"
            download
            @click="upDownloadcounter"
          >
            {{ file.name }}
          </a>
        </div>

        <!-- Author  -->
        <div class="file-author">{{ $t('courses.files.card.by') }} {{ fileAuthor }}</div>

        <!-- File Details -->
        <v-row class="mt-3" no-gutters>
          <!-- Upload date -->
          <v-col cols="auto" class="file-detail">
            <span class="file-detail-entry mr-2">
              <v-icon small class="pr-1"> mdi-calendar</v-icon>
              {{ fileUploadDate }}
            </span>
          </v-col>

          <!-- Download count -->
          <v-col cols="auto" class="file-detail">
            <span class="file-detail-entry mr-2">
              <v-icon small class="pr-1">mdi-download</v-icon>
              {{ file.downloadCount }}
            </span>
          </v-col>

          <!-- File extension -->
          <v-col cols="auto" class="file-detail">
            <span class="file-detail-entry mr-2">
              <v-icon small class="pr-1"> mdi-paperclip</v-icon>
              {{ fileExtension }}
            </span>
          </v-col>
        </v-row>
      </v-col>

      <!-- Ratings -->
      <v-col cols="12" sm="auto" order="3" order-sm="2" class="mt-3 mt-sm-0">
        <v-row
          class="fill-height"
          no-gutters
          justify="space-between"
          justify-sm="end"
          align="baseline"
          align-sm="start"
        >
          <!-- Ratings -->
          <v-col cols="auto">
            <suspense-mutation
              :mutation="updateRatingMutation"
              :success-timeout="2000"
              :error-timeout="2000"
              transition="fade"
              transition-mode="out-in"
              force-size
            >
              <!-- Loading -->
              <template #loading>
                <div class="studium-center">
                  <v-progress-circular color="primary" width="2" size="30" indeterminate />
                </div>
              </template>

              <!-- Success -->
              <template #success>
                <div class="studium-center">
                  <animated-check size="28" success />
                </div>
              </template>

              <!-- Error -->
              <template #error>
                <div class="studium-center">
                  <animated-check size="28" error />
                </div>
              </template>

              <!-- Component -->
              <template #component>
                <div class="d-flex d-sm-block">
                  <!-- Rating -->
                  <v-rating
                    v-model="fileRating"
                    :color="file.myRating ? color : 'secondary'"
                    right
                    length="5"
                    background-color="secondary"
                    dense
                    hover
                    size="20"
                  />

                  <!-- Rating details -->
                  <div class="file-detail d-flex justify-start justify-sm-end mr-sm-1 mt-sm-1">
                    <!-- Amount of ratings -->
                    <span class="file-detail-entry ml-2">
                      <v-icon small class="pr-1"> mdi-account-outline</v-icon>
                      {{ file.ratingsCount }}
                    </span>

                    <!-- Average rating -->
                    <span class="file-detail-entry ml-2">
                      <v-icon small class="pr-1"> mdi-star-outline</v-icon>
                      {{ fileAverageRating }}
                    </span>
                  </div>
                </div>
              </template>
            </suspense-mutation>
          </v-col>
        </v-row>
      </v-col>

      <!-- Actions  -->
      <v-col cols="auto" order="2" order-sm="3">
        <v-menu offset-y>
          <!-- Button -->
          <template #activator="{ on, attrs }">
            <v-btn icon depressed color="secondary" :ripple="false" small v-bind="attrs" v-on="on">
              <v-icon>mdi-dots-vertical </v-icon>
            </v-btn>
          </template>

          <!-- Dropdown -->
          <v-list>
            <!-- Report File -->
            <v-list-item @click="dialogReport = true">
              <!-- Icon -->
              <v-list-item-icon class="mr-2">
                <v-icon>mdi-alert-outline</v-icon>
              </v-list-item-icon>

              <!--  Content -->
              <v-list-item-content>
                <v-list-item-title>{{ $t('courses.files.card.report') }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>

            <!-- Delete File -->
            <v-list-item v-if="owner" @click="dialogDeleteConfirm = true">
              <!-- Icon -->
              <v-list-item-icon class="mr-2">
                <v-icon>mdi-delete-outline</v-icon>
              </v-list-item-icon>

              <!--  Content -->
              <v-list-item-content>
                <v-list-item-title>{{ $t('courses.files.card.delete') }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-col>
    </v-row>

    <!-- Report dialog -->
    <course-file-report-dialog :open.sync="dialogReport" :file="file" :course-code="courseCode" />

    <!-- Delete confirmation -->
    <confirmation-dialog
      :open.sync="dialogDeleteConfirm"
      :loading.sync="deleteDocumentMutation.loading.value"
      @confirm="onDeleteConfirm"
      @cancel="onDeleteCancel"
    >
      <template #description> {{ $t('courses.files.card.delete_sure') }} '{{ file.name }}'? </template>
    </confirmation-dialog>
  </v-card>
</template>

<script lang="ts">
import { computed, defineComponent } from '@nuxtjs/composition-api'
import ColorHash from 'color-hash'
import { format, parseISO } from 'date-fns'

import {
  CourseDocumentsDocument,
  useDeleteDocumentMutation,
  useUpdateRatingMutation,
  useUpDownloadcountMutation,
} from '~/apollo/_generated'
import { useErrorHandler, useRouterHash } from '~/util/composables'
import { slugify } from '~/util/helpers'

export default defineComponent({
  props: {
    file: {
      type: Object,
      required: true,
    },
    courseCode: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit, root }) {
    // Main tag for the file
    const fileTag = computed(() => props.file.tags.edges[0].node)

    // File author
    const fileAuthor = computed(() => {
      // If the file is posted anonymously, do not display the author
      if (props.file.anonymous) {
        return 'Anonymous'
      }

      // If the author of the file is null (and not anonymouses, as checked above)
      // something went wrong
      if (!props.file.author) {
        return 'Unknown Author'
      }

      return `${props.file.author.firstName} ${props.file.author.lastName}`
    })

    // Upload date of the file
    const fileUploadDate = computed(() => format(parseISO(props.file.uploadDate), 'dd/MM/yyyy'))

    // File download URL
    const fileDownloadUrl = computed(() => `/media/${props.file.file}`)

    // File extension
    const fileExtension = computed(() => props.file.file.split('.').pop())

    // Color for the file, based on the tags
    const color = computed(() => new ColorHash({ saturation: 0.5, lightness: 0.7 }).hex(fileTag.value.name))

    // Is user owner of the file
    const owner = computed(() => props.file.author?.username === root.$auth.user?.username)

    // Rating
    const updateRatingMutation = useUpdateRatingMutation({})
    const updateRatingError = useErrorHandler(updateRatingMutation)

    // Emit a potential rating error to the parent
    updateRatingMutation.onError(() => {
      emit('error', updateRatingError.value)
    })

    // Rating value
    const fileRating = computed({
      get: () => Number(props.file.myRating || props.file.averageRatings),
      set(value) {
        updateRatingMutation.mutate({ id: props.file.id, rating: value })
      },
    })

    // Average rating value
    const fileAverageRating = computed(() =>
      props.file.averageRatings ? props.file.averageRatings.toPrecision(2) : 'N/A'
    )

    // Delete document
    const deleteDocumentMutation = useDeleteDocumentMutation({
      update: (cache, { data: deleteData }) => {
        // Fetch the list with documents for the course from the cache
        const data: any = cache.readQuery({
          query: CourseDocumentsDocument,
          variables: { code: props.courseCode },
        })

        const docs = data.courseByCode.documents.edges
        let index = -1

        // Find index of the document in th array
        for (let i = 0; i < docs.length; i++) {
          if (docs[i].node.name === deleteData?.deleteDocument?.document?.name) {
            index = i
            break
          }
        }

        // If index is found, remove document from cache
        if (index > -1) {
          // Emit done here, since if we do it afterwards,
          // document and hence card is already gone and emit
          // won't be catched in parent.
          emit('success', 'File succesfully removed.')
          data.courseByCode.documents.edges.splice(index, 1)
        }

        // Update the cache
        cache.writeQuery({ query: CourseDocumentsDocument, data })
      },
    })
    const deleteDocumentError = useErrorHandler(deleteDocumentMutation)

    // Emit a potential rating error to the parent
    deleteDocumentMutation.onError(() => {
      emit('error', deleteDocumentError.value)
    })

    // Should the report dialog be open
    const dialogReport = useRouterHash(`report-${slugify(props.file.name)}`)

    // Should the delete confirmation dialog be open
    const dialogDeleteConfirm = useRouterHash(`delete-${slugify(props.file.name)}`)

    // On delete confirm
    function onDeleteConfirm() {
      deleteDocumentMutation.mutate({ id: props.file.id }).then(() => (dialogDeleteConfirm.value = false))
    }

    // On delete cancel
    function onDeleteCancel() {
      dialogDeleteConfirm.value = false
    }

    const downMut = useUpDownloadcountMutation({})
    function upDownloadcounter() {
      downMut.mutate({ id: props.file.id })
    }

    return {
      fileTag,
      fileAuthor,
      fileUploadDate,
      fileDownloadUrl,
      fileExtension,
      color,
      owner,
      updateRatingMutation,
      updateRatingError,
      fileRating,
      fileAverageRating,
      deleteDocumentMutation,
      dialogReport,
      dialogDeleteConfirm,
      onDeleteConfirm,
      onDeleteCancel,
      upDownloadcounter,
    }
  },
})
</script>

<style lang="scss" scoped>
.file {
  &-name {
    color: $primary !important;
    border-bottom: 1px solid transparent;
    font-weight: 600;
    font-size: 17px;
    padding-top: 0;
    transition: all 0.2s cubic-bezier(0.4, 0, 0.6, 1);

    &:hover {
      color: lighten($primary, 20%);
      border-color: lighten($primary, 20%);
    }
  }

  &-author {
    color: $secondary;
  }

  &-detail {
    color: $secondary;
    font-size: 16px;
    font-weight: 400;
    letter-spacing: inherit !important;

    &-entry {
      white-space: nowrap;
      display: flex;
      align-items: center;
    }
  }
}
</style>
